#!/usr/bin/perl

my $DOWN_DIR;
my $TIMEOUT;
my $WGET;
my $EMAIL;
my $SMTP;

&loadPreferences;

# Headers
print "Pragma: no-cache\n";
print "Cache-control: no-cache\n";
print "Connection: close\n";
print "Content-type: text/html\n\n";

my $top = &top;

print <<"END";
<html>
 <head>
  <title>:: ReDoMa ::</title>
  <link rel="SHORTCUT ICON" href="favicon.ico">
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
  <meta http-equiv="expires" content="0">
END

if((@ARGV[0] eq 'transfers')&&($values{"DATA_url"} ne 'yes')&&($ARGV[0] ne 'schedule'))
{
print <<"END";
  <meta http-equiv=refresh content="$TIMEOUT; url=index.cgi?transfers">
END
}
	 
print <<"END";
  <link rel="stylesheet" href="index.css" type="text/css"/>
 </head>
 <body topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<table class="tableTop">
 <tr>
  <td>
   $top 
  </td>
 </tr>
</table>
<br>
<br>
END

&parseForm;

my @database;
&loadDatabase;

my @schedule;
&loadSchedule;

if(($ARGV[0] eq 'welcome')){print welcome();}

if(($ARGV[0] eq 'add') && (!$values{"DATA_url"})){print &add;}
if(($ARGV[0] eq 'add') && ($values{"DATA_url"})){print &addValidation;}

my $out = '';
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'add'))
{ 
 $out = &transfersAdd;
 if($out==1) {$out='';}
 if($out ne '')
 {
  print $out;
 }
}
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'sendmail')){&transfersSendmail;}
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'dontsendmail')){&transfersDontsendmail;}
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'resume')){&transfersResume;}
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'restart')){&transfersRestart;}
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'pause')){&transfersPause;}
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'cancel')){&transfersCancel;}
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'clear') && ($ARGV[2] eq 'done')){&transfersClearDone;}
if(($ARGV[0] eq 'transfers') && ($ARGV[1] eq 'clear') && ($ARGV[2] ne 'done')){&transfersClear;}
if(($ARGV[0] eq 'transfers') && ($out eq '')) {print &transfers; }

if(($ARGV[0] eq 'schedule') && ($ARGV[1] eq 'ask' )) {print &scheduleAsk; }
if(($ARGV[0] eq 'schedule') && ($ARGV[1] eq 'add' )) {&scheduleAdd; }
if(($ARGV[0] eq 'schedule') && ($ARGV[1] eq 'cancel' )) {&scheduleCancel; }
if(($ARGV[0] eq 'schedule') && ($ARGV[1] ne 'ask' )) {print &schedule; }

if(($ARGV[0] eq 'files') && ($ARGV[1] eq 'delete')){&filesDelete;}
if(($ARGV[0] eq 'files')) {print &files; }

if(($ARGV[0] eq 'options') && (!$values{"DATA_wget"})){print &options;}
if(($ARGV[0] eq 'options') && ($values{"DATA_wget"})){print &optionsSave;}

print <<"END";
 </body>
</html>
END

sub getPID
{
 open (PID, shift) || die "couldn't open the file!";
 my $pid = <PID>; 
 close(PID);
 return trim($pid);
}

sub loadPreferences
{
 my @data = file('redoma.conf');
 $DOWN_DIR = @data[0];
 $WGET     = @data[1];
 $TIMEOUT  = @data[2];
 $EMAIL    = @data[3];
 $SMTP     = @data[4];

 if($DOWN_DIR eq '')
 {
  $DOWN_DIR ='Downloads'
 }
 if($WGET eq '')
 {
  $WGET = '/usr/local/bin/wget';
 }
 if($TIMEOUT eq '')
 {
  $TIMEOUT = '30';
 }
}

sub savePreferences
{
 open (OPTIONS, ">redoma.conf") or die "no such file";
 print OPTIONS"$DOWN_DIR\n";
 print OPTIONS"$WGET\n";
 print OPTIONS"$TIMEOUT\n";
 print OPTIONS"$EMAIL\n";
 print OPTIONS"$SMTP\n";
 close(OPTIONS);
}

sub loadDatabase
{
 open (TRANSFERS, "transfers.db") || die "couldn't open the file!";
 my $i = 0;
 while ($record = <TRANSFERS>) 
 {
  if(trim($record) ne '')
  {
   @database[$i] = trim($record);
   $i=$i+1;
  }
 }
 close(TRANSFERS);

 @database = sort {&byFileName ($a,$b)} @database ;
}


sub byFileName 
{
 my @fieldsA = explode('|',shift);
 my @fieldsB = explode('|',shift);
 return (uc(@fieldsA[2])  cmp uc(@fieldsB[2])); 
}


sub saveDatabase
{
 @database = sort {&byFileName ($a,$b)} @database ;

 open (TRANSFERS, ">transfers.db") or die "no such file";
 foreach (@database) 
 {
  if(trim($_) ne '')
  {
   print TRANSFERS "$_\n";
  } 
  #print $_;
 }
 close(TRANSFERS);
}

sub loadSchedule
{
 open (TRANSFERS, "schedules.db") || die "couldn't open the file!";
 my $i = 0;
 while ($record = <TRANSFERS>) 
 {
  if(trim($record) ne '')
  {
   @schedule[$i] = trim($record);
   $i=$i+1;
  }
 }
 close(TRANSFERS);

 @schedule = sort {&byScheduleName ($a,$b)} @schedule;
}

sub byScheduleName 
{
 my @fieldsA = explode('|',shift);
 my @fieldsB = explode('|',shift);
 my $myA;
 my $myB;

 foreach(@database)
 {
  @lines = explode('|',$_);
  if(@lines[0] eq @fieldsA[1]) {$myA = @lines[2];}
  if(@lines[0] eq @fieldsB[1]) {$myB = @lines[2];}
 }

 return (uc($myA) cmp uc($myB)); 
}

sub saveSchedule
{
 @schedule = sort {&byScheduleName ($a,$b)} @schedule;

 open (TRANSFERS, ">schedules.db") or die "no such file";
 foreach (@schedule) 
 {
  if(trim($_) ne '')
  {
   print TRANSFERS "$_\n";
  } 
  #print $_;
 }
 close(TRANSFERS);
}

sub start
{
 my $url = shift;
 my $name = shift;

 my $a1=$DOWN_DIR.'/'.$name.'.log';
 my $a2=$DOWN_DIR.'/'.$name;
 my $a3=$url;
 my $a4=$DOWN_DIR.'/'.$name.'.pid';
 
 my $command = "$WGET -b -c -o $a1 -O $a2 $a3"; 
 my $pidSring = `$command`;
 #print $pidSring ."<br>";
 my @pieces = split(/pid/,$pidSring);
 @pieces=split(/\./,$pieces[1]);
 $pid = trim($pieces[0]);

 open (PID, ">$a4") or die "no such file";
 print PID"$pid\n";
 close(PID);
}

sub filesDelete
{
 $filename = urlDecode(@ARGV[2]);

 my $file = $DOWN_DIR.'/'.$filename ;
 my $pidFile = $DOWN_DIR.'/'.$filename.'.pid';
 my $logFile = $DOWN_DIR.'/'.$filename.'.log';

 if(fileExists($file))
 {
  unlink($file);
 } 
 if(fileExists($pidFile))
 {
  unlink($pidFile);
 } 
 if(fileExists($logFile))
 {
  unlink($logFile);
 } 
 my @dbCopy;
 my $count = 0;
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[2] eq  $filename)
  {

   my @dbCopy2;
   my $count2 = 0;
   foreach(@schedule)
   {
    @fields2 = explode('|',$_);
    if($fields2[1] eq  $fields[0])
    {
    }
    else
    {
     @dbCopy2[$count2]=$_;
     $count2++;
    }
   }
   @schedule=@dbCopy2;
   &saveSchedule;

  } 
  else
  {
   @dbCopy[$count]=$_;
   $count++;
  }
 }
 @database=@dbCopy;
 &saveDatabase;
}

sub files
{
 my $totalSize = 0;

 opendir(DIR, $DOWN_DIR.'/') || die "$DOWN_DIR: $!";
 my @Files = readdir(DIR);
 closedir(DIR);

 my @Downloaded;
 my $i = 0;
 foreach(@Files)
 {
  my $file = $DOWN_DIR.'/'.$_;
  if(isFile($file))
  {
   my $ext = substr($_,length($_)-3,3);
   if($ext ne 'pid' && $ext ne 'log')
   {

    my $log=$DOWN_DIR.'/'.$_.'.log';
    my $pid=$DOWN_DIR.'/'.$_.'.pid';
 
    my $show = 0;
    if(!fileExists($log) && !fileExists($pid))
    {
     $show = 1; 
    }
    if(fileExists($log))
    {
     my $done = '???';
     my @log = file($log);
     foreach(@log)
     {
      $line=$_;
      if($line ne '')
      {
       my @pieces = split(/%/,$line);
       $search = 'B/s'; 
       if($pieces[1] =~ /$search/g)
       {
        $speed=trim($pieces[1]);
        @pieces = split(/OK/,$pieces[0]);
        $done = trim(substr($pieces[0],length($pieces[0])-3,length($pieces[0])));
       }  
      }
      if($done eq '100') 
      {
       $show = 1;
      } 	
     }
     if($done eq '???')
     {
      $show = 1;
     }
    }

    if($show == 1)
    {
     @Downloaded[$i]=$_;
     $i++; 
    }
   }
  }   
 }

 my @Downloaded= sort {uc($a) cmp uc($b)} @Downloaded;

 $count = @Downloaded;

 my $code= <<"END";
<script>
 function _DELETE(ID,FILE)
 {
  Check = confirm('Are you sure to delete the file '+FILE+'?');
  if(Check == true) document.location.href='index.cgi?files+delete+'+ID;
 }
</script>


<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr>
   <td class="tableInnerHead">
    <span class="whiteText">
     <b>Files downloaded ($count)</b>
    </span>
   </td>
  </tr>
  <tr>
   <td>
    <table border="0" cellpadding="3" cellspacing="0" width="100%">
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Filename
      </td>
      <td class="whiteTextTop" align="right">
        Size
      </td>
      <td class="whiteTextTop" align="right">
        Date
      </td>
      <td class="whiteTextTop" align="right">
        Actions
      </td>
     </tr>
END

 if($count>0)
 {
  $count=0;
  foreach(@Downloaded) 
  {
   $count++;
   my $filename = $DOWN_DIR.'/'.$_;
   my $size = fileSize($filename); 
   $totalSize+=$size;
   $size = niceSize($size);
   my $URLfile=strReplace("'","\\'",urlEncode($_));
   my $fileOther=strReplace("'","\\'",$_);

   my @date=localtime((stat($filename))[9]);
   my $datestring=sprintf("%04d.%02d.%02d @ %02d:%02d:%02d",($date[5]+1900),($date[4]+1),$date[3],$date[2],$date[1],$date[0]);

  if(($count % 2) == 0)
  {
  $code.= <<"END";
     <tr class="hell">
END
  }
  else
  { 
  $code.= <<"END";
     <tr>
END
  }
########################
## SME spcifique ??? ##
## voir avec ARGENLOS ##
########################
#  $filename =~ s/html//;
  $code.= <<"END";
      <td class="whiteText">$_</td>
      <td class="whiteText" align="right">$size</td>
      <td class="whiteText" align="right">$datestring</td>
      <td class="whiteTextTop" align="right">
       <a href="$filename"><img src="Pictures/link.gif" border="0" alt="Download file"></a>
       <a href="javascript:_DELETE('$URLfile','$URLfile')"><img src="Pictures/cancel.gif" border="0" alt="Delete file"></a>
      </td>
     </tr>
END
  } 
 }
 else
 {
 $code.= <<"END";
    <tr class="tableInnerHeaderError">
     <td class="whiteTextTop">
       no files downloaded yet...
     </td>
     <td class="whiteTextTop" align="right">&nbsp;
     </td>
     <td class="whiteTextTop" align="right">&nbsp;
     </td>
     <td class="whiteTextTop" align="right">&nbsp;
     </td>
    </tr>
END
 }

 $totalSize=niceSize($totalSize);
 $code.= <<"END";
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">Totals</td>
      <td class="whiteTextTop" align="right" style="width:80px">$totalSize</td>
      <td class="whiteTextTop" align="right" style="width:150px">&nbsp;</td>
      <td class="whiteTextTop" style="width:50px">
      </td>
     </tr>
    </table>
   </td>
  </tr>
 </table>
</center>
END

 return $code;
}

sub transfersSendmail
{
 my @dbCopy; 
 my $count = 0;
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[0] eq  @ARGV[2])
  {
   @dbCopy[$count]=@fields[0].'|'.@fields[1].'|'.@fields[2].'|1';
  }
  else
  {
   @dbCopy[$count]=$_;
  }
  $count++;
 }
 @database=@dbCopy;
 &saveDatabase;
}

sub transfersDontsendmail
{
 my @dbCopy; 
 my $count = 0;
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[0] eq  @ARGV[2])
  {
   @dbCopy[$count]=@fields[0].'|'.@fields[1].'|'.@fields[2].'|0';
  }
  else
  {
   @dbCopy[$count]=$_;
  }
  $count++;
 }
 @database=@dbCopy;
 &saveDatabase;
}

sub transfersAdd
{
 my @dbCopy; 
 my $count = 0;
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[2] eq  $values{"DATA_name"})
  {
   my $file = $DOWN_DIR.'/'.$values{"DATA_name"};
   my $pidFile = $DOWN_DIR.'/'.$values{"DATA_name"}.'.pid';
   my $logFile = $DOWN_DIR.'/'.$values{"DATA_name"}.'.log'; 

   if(fileExists($file))
   {
    unlink($file);
   } 
   if(fileExists($pidFile))
   {
    unlink($pidFile);
   } 
   if(fileExists($logFile))
   {
    unlink($logFile);
   } 
  }
  else
  {
   @dbCopy[$count]=$_;
   $count++;
  }
 }
 @database=@dbCopy;
 &saveDatabase;

 my $found = 0;
 opendir(DIR, $DOWN_DIR.'/') || die "$DOWN_DIR: $!";
 my @Files = readdir(DIR);
 closedir(DIR);
 foreach(@Files)
 {
  if($_ eq $values{"DATA_name"})
  {
   $found = 1; 
  }
 }

 if($found == 1)
 {
   my $file = $DOWN_DIR.'/'.$values{"DATA_name"};
   my $pidFile = $DOWN_DIR.'/'.$values{"DATA_name"}.'.pid';
   my $logFile = $DOWN_DIR.'/'.$values{"DATA_name"}.'.log';

   if(fileExists($file))
   {
    unlink($file);
   } 
   if(fileExists($pidFile))
   {
    $pid = getPID($pidFile);
    if(isDir('/proc/'.$pid))
    {
    `kill -9 $pid`;
    }

    unlink($pidFile);
   } 
   if(fileExists($logFile))
   {
    unlink($logFile);
   }
 }

 $last = @database;
 my $max = 0;
 foreach(@database)
 {
  @fields=explode('|',$_);
  if($max<=$fields[0])
  {
   $max = $fields[0];
  }
 }
 $max++;

# $last=@database;
# $listEntry=@database[$last-1];
# @fields = explode('|',$listEntry);
# $max=$fields[0]+1;
 my $mail = '0';
 if($values{"DATA_mail"} eq 'yes') {$mail = '1';}
 #else {$mail='0';}
 #print("-------------------->".$values{"DATA_mail"});
 @database[$last]=$max.'|'.$values{"DATA_url"}.'|'.$values{"DATA_name"}.'|'.$mail;
 &saveDatabase;

 if($values{"DATA_schedule"} eq 'yes')
 {
  # schedule
  @ARGV[2]=$max;
  return &scheduleAsk;
 }
 else
 {
  &start($values{"DATA_url"},$values{"DATA_name"});
  return '';
 }
}

sub transfersResume
{
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[0] eq  @ARGV[2])
  {
   &start($fields[1],$fields[2]);
  }
 }
}

sub transfersRestart
{
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[0] eq  @ARGV[2])
  {
   my $file = $DOWN_DIR.'/'.$fields[2];
   my $pidFile = $DOWN_DIR.'/'.$fields[2].'.pid';
   my $logFile = $DOWN_DIR.'/'.$fields[2].'.log';

   if(fileExists($file))
   {
    unlink($file);
   } 
   if(fileExists($pidFile))
   {
    unlink($pidFile);
   } 
   if(fileExists($logFile))
   {
    unlink($logFile);
   }
   &start($fields[1],$fields[2]);
  }
 }
}

sub transfersPause
{
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[0] eq  @ARGV[2])
  {
   my $pidFile = $DOWN_DIR.'/'.$fields[2].'.pid';
   if(fileExists($pidFile))
   {
    $pid = getPID($pidFile);
    if(isDir('/proc/'.$pid))
    {
    `kill -9 $pid`;
    }
    unlink($pidFile);
   } 
  }
 }
}

sub transfersCancel
{
 my @dbCopy;
 my $count = 0;
 foreach(@schedule)
 {
  @fields = explode('|',$_);
  if($fields[1] eq  @ARGV[2])
  {
  }
  else
  {
   @dbCopy[$count]=$_;
   $count++;
  }
 }
 @schedule=@dbCopy;
 &saveSchedule;

 &transfersPause;
 my @dbCopy;

 my $count = 0;
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[0] eq  @ARGV[2])
  {
   my $file = $DOWN_DIR.'/'.$fields[2];
   my $pidFile = $DOWN_DIR.'/'.$fields[2].'.pid';
   my $logFile = $DOWN_DIR.'/'.$fields[2].'.log';

   if(fileExists($file))
   {
    unlink($file);
   } 
   if(fileExists($pidFile))
   {
    unlink($pidFile);
   } 
   if(fileExists($logFile))
   {
    unlink($logFile);
   } 
  }
  else
  {
   @dbCopy[$count]=$_;
   $count++;
  }
 }
 @database=@dbCopy;
 &saveDatabase;
}

sub transfersClearDone
{
 my $schduled = 0;
 my @Sfields;
 my @dbCopy;
 my $count = 0;
 foreach(@database)
 {
  @fields = explode('|',$_);
  my $done='???';
  
  $schduled = 0;

  foreach(@schedule)
  {
   @Sfields = explode('|',$_);
   if($Sfields[1] eq  @fields[0])
   {
    $schduled = 1;
   }
  }

  if($schduled==0)
  {
   if(fileExists($DOWN_DIR.'/'.$fields[2].'.log'))
   { 
    my @log = file($DOWN_DIR.'/'.$fields[2].'.log');
    foreach(@log)
    {
     $line=$_;
     if($line ne '')
     {
      my @pieces = split(/%/,$line);
      $search = 'B/s'; 
      if($pieces[1] =~ /$search/g)
      {
       $speed=trim($pieces[1]);
       @pieces = split(/OK/,$pieces[0]);
       $done = trim(substr($pieces[0],length($pieces[0])-3,length($pieces[0])));
      }

     }
    }
   }
   else
   {
    $done='0';
   } 

   if($done eq '100')
   {
    my $pidFile = $DOWN_DIR.'/'.$fields[2].'.pid';
    my $logFile = $DOWN_DIR.'/'.$fields[2].'.log';  

    if(fileExists($pidFile))
    {
     unlink($pidFile);
    } 
    if(fileExists($logFile))
    {
     unlink($logFile);
    }
   }
   else
   {
    @dbCopy[$count]=$_;
    $count++;
   }
  }
  else
  {
    @dbCopy[$count]=$_;
    $count++;
  }
 }
 @database=@dbCopy;
 &saveDatabase;
}

sub transfersClear
{
 &transfersPause;
 my @dbCopy;

 my $count = 0;
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($fields[0] eq  @ARGV[2])
  {
   my $pidFile = $DOWN_DIR.'/'.$fields[2].'.pid';
   my $logFile = $DOWN_DIR.'/'.$fields[2].'.log';

   if(fileExists($pidFile))
   {
    unlink($pidFile);
   } 
   if(fileExists($logFile))
   {
    unlink($logFile);
   } 
  }
  else
  {
   @dbCopy[$count]=$_;
   $count++;
  }
 }
 @database=@dbCopy;
 #&saveDatabase;
}

sub transfers
{
 my $totalSize=0;
 my $totalTransferred=0;
 my $totalSpeed=0;
 my $count = @database;

 my $code= <<"END";
<script>
 function _CANCEL(ID,FILE)
 {
  Check = confirm('Are you sure to cancel the download for '+FILE+'?');
  if(Check == true) document.location.href='index.cgi?transfers+cancel+'+ID;
 }

 function _CLEAR()
 {
  document.location.href='index.cgi?transfers+clear+done';
 }
</script>

<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr>
   <td class="tableInnerHead">
    <span class="whiteText">
     <b>Downloads ($count)</b>
    </span>
   </td>
  </tr>
  <tr>
   <td>
    <table border="0" cellpadding="3" cellspacing="0" width="100%">
    <tr class="tableInnerHeader">
     <td class="whiteTextTop">
       Filename
     </td>
     <td class="whiteTextTop" align="right">
       Size
     </td>
     <td class="whiteTextTop" align="right">
       Transferred
     </td>
     <td class="whiteTextTop" align="right">
       Speed
     </td>
     <td class="whiteTextTop" align="right">
       Completed
     </td>
     <td class="whiteTextTop" align="right">
       State
     </td>
     <td class="whiteTextTop" align="right">
       Actions
     </td>
    </tr>
END

 if($count>0)
 {
  $count = 0;
  foreach (@database) 
  {
   $count++;

   @fields = explode('|',$_);

   my $acro = strReplace("'","\\'",$fields[1]);
   my $name = $fields[2];
	
   my $size=0; 
   if(fileExists($DOWN_DIR.'/'.$fields[2]))
   {
    $size=fileSize($DOWN_DIR.'/'.$fields[2]); 
   }
   $totalTransferred+=$size;

   my $state = 'stopped';
   if(fileExists($DOWN_DIR.'/'.$fields[2].'.pid'))
   {
    $pid = getPID($DOWN_DIR.'/'.$fields[2].'.pid') ;
    if(isDir('/proc/'.$pid))
    {
     $state='running';
    }
    else
    {
     $state='stopped';
    }
   }

   foreach(@schedule) 
   {
    @lines = explode('|',$_);
    if((@lines[1] eq $fields[0]) && ($state ne 'running'))
    {
     $state = 'scheduled';
    }
   }

   my $done='???';
   my $speed='??? B/s';
   my $whatError = '';
   my $length='unspecified';
   if(fileExists($DOWN_DIR.'/'.$fields[2].'.log'))
   { 
    my @log = file($DOWN_DIR.'/'.$fields[2].'.log');
    foreach(@log)
    {
     $line=$_;
     if($line ne '')
     {
      my $search = 'Length:'; 
      if($line =~ /$search/g)
      {
       my @pieces = split(/:/,$line);
       @pieces = split(/\[/,$pieces[1]);
       @pieces = split(/\(/,$pieces[0]);
	$length = strReplace(',','',$pieces[0]);
       $totalSize+=$length ;
      }
  
      my $search = 'ERROR'; 
      if($line =~ /$search/g)
      {
        $where = pos($line);
        $state = 'error';
        $whatError = '#'.substr($line,$where,4);
      }

      my @pieces = split(/%/,$line);
      $search = 'B/s'; 
      if($pieces[1] =~ /$search/g)
      {
       $speed=trim($pieces[1]);
       #print $speed."<br>";

       @pieces = split(/OK/,$pieces[0]);
       #print $pieces[0].'<br>'; 
       $done = trim(substr($pieces[0],length($pieces[0])-3,length($pieces[0])));
       #print $done."<br>";
      }

     }
    }

    if($speed ne '??? B/s')
    { 
     my @others=split(/ /,$speed);
     my $baseSpeed = @others[0];
     if(@others[1] eq 'KB/s') {$baseSpeed*=1024;}
     if(@others[1] eq 'MB/s') {$baseSpeed*=1024*1024;}
     if(@others[1] eq 'GB/s') {$baseSpeed*=1024*1024*1024;} # just for fun :-)
     #print $baseSpeed."<br>";
     if($state eq 'running')
     {
      $totalSpeed+=$baseSpeed;
     }
    }

   }
   else
   {
    $done='0';
   } 

   if($state ne 'running')
   { 
    $speed = '&nbsp;';
   }

   if(($done eq '100') && ($state ne 'scheduled'))
   {
    $state='done';
   }

   

  $length=niceSize($length);
  $size=niceSize($size);

  if(($count % 2) == 0)
  {
  $code.= <<"END";
     <tr class="hell">
END
  }
  else
  { 
  $code.= <<"END";
     <tr>
END
  }
  $code.= <<"END";
      <td class="whiteText"><acronym title="$acro">$name</acronym></td>
      <td class="whiteText" align="right">$length</td>
      <td class="whiteText" align="right">$size</td>
      <td class="whiteText" align="right">$speed</td>
      <td class="whiteText" align="right">$done%</td>
      <td class="whiteText" align="right"><acronym title="$whatError">$state</acronym>
END
   if($fields[3] eq '1' || ($fields[3] eq '2' && $state eq 'scheduled'))
   {
  $code.= <<"END";
       <img src="Pictures/mail.gif" border="0" alt="Mail alert is *ON* for this download!">
END
   }
   if($fields[3] eq '2' && $done eq '100' && $state eq 'done')
   {
  $code.= <<"END";
       <img src="Pictures/mailok.gif" border="0" alt="A mail alert for this download has been send...">
END
   }
  $code.= <<"END";
</td>
      <td class="whiteText" align="right">
END
  
   if($done ne '100')
   {
    if($state eq 'running')
    {
  $code.= <<"END";
       <a href="index.cgi?transfers+pause+$fields[0]"><img src="Pictures/pause.gif" border="0" alt="Pause download"></a>
END
    }
    else
    {
#      if($state ne 'error')
#      {
  $code.= <<"END";
       <a href="index.cgi?transfers+resume+$fields[0]"><img src="Pictures/resume.gif" border="0" alt="Resume download"></a>
END
#      }
     if($done eq '???' && $size ne '0&nbsp;B')
     {
  $code.= <<"END";
       <a href="index.cgi?transfers+clear+$fields[0]"><img src="Pictures/clear.gif" border="0" alt="Clear from list"></a>
END
     }
    }
   }
   else
   {
     if($done eq '100')
     {
  $code.= <<"END";
       <a href="index.cgi?transfers+clear+$fields[0]"><img src="Pictures/clear.gif" border="0" alt="Clear from list"></a>
END
     }
   }
  $code.= <<"END";
       <a href="javascript:_CANCEL('$fields[0]','$name')"><img src="Pictures/cancel.gif" border="0" alt="Cancel download"></a>
END
  
   if($state ne 'running' && $state ne 'error')
   {
  $code.= <<"END";
       <a href="index.cgi?transfers+restart+$fields[0]"><img src="Pictures/restart.gif" border="0" alt="Restart download"></a>
       <a href="index.cgi?schedule+ask+$fields[0]"><img src="Pictures/schedule.gif" border="0" alt="Schedule download"></a>
END
   }
   if($state ne 'error')
   {
    if(($fields[3] eq '0' || $fields[3] eq '') && $state ne 'done')
    {
  $code.= <<"END";
       <a href="index.cgi?transfers+sendmail+$fields[0]"><img src="Pictures/sendmail.gif" border="0" alt="Send a mail alert for this download."></a>
END
 	    }
    if($fields[3] eq '1' || $fields[3] eq '2')
    {
  $code.= <<"END";
       <a href="index.cgi?transfers+dontsendmail+$fields[0]"><img src="Pictures/dontsendmail.gif" border="0" alt="Do not send a mail alert for this download."></a>
END
    }

   }
  $code.= <<"END";
      </td>
     </tr>
END
  
  }
 }
 else
 {
  $code.= <<"END";
    <tr class="tableInnerHeaderError">
     <td class="whiteTextTop">
       no files to download ...
     </td>
     <td class="whiteTextTop" align="right">
     </td>
     <td class="whiteTextTop" align="right">
     </td>
     <td class="whiteTextTop" align="right">
     </td>
     <td class="whiteTextTop" align="right">
     </td>
     <td class="whiteTextTop" align="right">
     </td>
     <td class="whiteTextTop" align="right">
     </td>
    </tr>
END
 }

 $totalSize=niceSize($totalSize);
 $totalTransferred=niceSize($totalTransferred);
 $totalSpeed=niceSpeed($totalSpeed);
 $code.= <<"END";
    <tr class="tableInnerHeader">
     <td class="whiteTextTop">
       Totals
     </td>
     <td class="whiteTextTop" style="width:80px" align="right">
       $totalSize
     </td>
     <td class="whiteTextTop" style="width:80px" align="right">
       $totalTransferred
     </td>
     <td class="whiteTextTop" style="width:80px" align="right">
       $totalSpeed
     </td>
     <td class="whiteTextTop" style="width:80px">

     </td>
     <td class="whiteTextTop" style="width:80px" align="right">

     </td>
     <td class="whiteTextTop" align="right" style="width:115px">
      <input type="button" value="Clear completed" class="blackText" style="width:100%" onClick="_CLEAR()">
     </td>
    </tr>
    </table>
   </td>
  </tr>
 </table>
</center>
END

 return $code;
}

sub scheduleAsk
{
 # Get date
 my @date=localtime(time());
 my $year   = sprintf("%04d",$date[5]+1900);
 my $month  = sprintf("%02d",$date[4]+1);
 my $day    = sprintf("%02d",$date[3]);
 my $hour   = sprintf("%02d",$date[2]);
 my $minute = sprintf("%02d",$date[1]);

   my $name = '';
   my $acro = '';
   foreach (@database) 
   {
    @files = explode('|',$_);
    if(@files[0] eq @ARGV[2])
    {
     $name = @files[2];
     $acro = @files[1];
    }
   }

 my $id=@ARGV[2];

 my $code = <<"END";
<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr>
   <td class="tableInnerHead">
    <span class="whiteText">
     <b>Schedule a download</b>
    </span>
   </td>
  </tr>
  <tr>
   <td>
    <table border="0" cellpadding="3" cellspacing="0" width="100%">
     <form action="index.cgi?schedule+add" method="post">
     <input type="hidden" name="DATA_id" value="$id">
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        URL
      </td>
     </tr>
     <tr>
      <td class="whiteText" class="text">
       $acro
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Filename
      </td>
     </tr>
     <tr>
      <td class="whiteText" class="text">
       $name
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Date
      </td>
     </tr>
     <tr>
      <td class="whiteText" class="text">
       <select name="DATA_year" class="blackText">
        <option selected>????
END

 for(my $i=2003;$i<=2010;$i++)
 {
  if($i eq $year) 
  { 
   $code.="<option selected>$i";
  }
  else 
  { 
   $code.="<option>$i";
  }
 }

 $code .= <<"END";
       </select>
	.
       <select name="DATA_month" class="blackText">
        <option selected>??
END

 for(my $i=01;$i<=12;$i++)
 {
  my $ii = sprintf("%02d",$i); 
  if($ii eq $month) 
  { 
   $code.="<option selected>$ii";
  }
  else 
  { 
   $code.="<option>$ii";
  }
 }

 $code .= <<"END";
       </select>
	.
       <select name="DATA_day" class="blackText">
        <option selected>??
END

 for(my $i=01;$i<=31;$i++)
 {
  my $ii = sprintf("%02d",$i); 
  if($ii eq $day) 
  { 
   $code.="<option selected>$ii";
  }
  else 
  { 
   $code.="<option>$ii";
  }
 }

 $code .= <<"END";
       </select>
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Time
      </td>
     </tr>
     <tr>
      <td class="whiteText" class="text">
       <select name="DATA_hour" class="blackText">
        <option selected>??
END

 for(my $i=00;$i<=23;$i++)
 {
  my $ii = sprintf("%02d",$i); 
  if($ii eq $hour) 
  { 
   $code.="<option selected>$ii";
  }
  else 
  { 
   $code.="<option>$ii";
  }
 }

 $code .= <<"END";
       </select>
       :
       <select name="DATA_minute" class="blackText">
        <option selected>??
END

 for(my $i=00;$i<=60;$i++)
 {
  my $ii = sprintf("%02d",$i); 
  if($ii eq $minute) 
  { 
   $code.="<option selected>$ii";
  }
  else 
  { 
   $code.="<option>$ii";
  }
 }

 $code .= <<"END";
       </select>
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop" align="right">
       <input type="submit" value="Schedule it" class="blackText">
      </td>
     </tr>
     </form>
    </table>
   </td>
  </tr>
 </table>
</center>
END

return $code;
}

sub scheduleCancel
{
 my @dbCopy;
 my $count = 0;
 foreach(@schedule)
 {
  @fields = explode('|',$_);
  if($fields[0] eq  @ARGV[2])
  {
  }
  else
  {
   @dbCopy[$count]=$_;
   $count++;
  }
 }
 @schedule=@dbCopy;
 &saveSchedule;
}

sub scheduleAdd
{
 $last = @schedule;
 my $max = 0;
 foreach(@schedule)
 {
  @fields=explode('|',$_);
  if($max<=$fields[0])
  {
   $max = $fields[0];
  }
 }
 $max++;
 @schedule[$last]=$max.'|'.$values{"DATA_id"}.'|'.$values{"DATA_year"}.'|'.$values{"DATA_month"}.'|'.$values{"DATA_day"}.'|'.$values{"DATA_hour"}.'|'.$values{"DATA_minute"};
 &saveSchedule;
}

sub schedule
{
 my $count = @schedule;

 my $code= <<"END";
<script>
 function _CANCEL(ID,FILE)
 {
  Check = confirm('Are you sure to cancel the scheduled download for '+FILE+'?');
  if(Check == true) document.location.href='index.cgi?schedule+cancel+'+ID;
 }
</script>

<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr>
   <td class="tableInnerHead">
    <span class="whiteText">
     <b>Scheduled downloads ($count)</b>
    </span>
   </td>
  </tr>
  <tr>
   <td>
    <table border="0" cellpadding="3" cellspacing="0" width="100%">
    <tr class="tableInnerHeader">
     <td class="whiteTextTop">
       Filename
     </td>
     <td class="whiteTextTop" align="right">
       Date
     </td>
     <td class="whiteTextTop" align="right">
       Time
     </td>
     <td class="whiteTextTop" align="right">
       Actions
     </td>
    </tr>
END
 if($count>0)
 {
  $count=0;
  foreach (@schedule) 
  {
   $count++;
   @fields = explode('|',$_);
   
   my $name = '';
   my $acro = '';
   foreach (@database) 
   {
    @files = explode('|',$_);
    if(@files[0] eq @fields[1])
    {
     $name = @files[2];
     $acro = @files[1];
    }
   }

   my $date=@fields[2].'.'.@fields[3].'.'.trim(@fields[4]);
   my $time=@fields[5].':'.@fields[6];

  if(($count % 2) == 0)
  {
  $code.= <<"END";
     <tr class="hell">
END
  }
  else
  { 
  $code.= <<"END";
     <tr>
END
  }
  $code.= <<"END";
      <td class="whiteText"><acronym title="$acro">$name</acronym></td>
      <td class="whiteText" align="right">$date</td>
      <td class="whiteText" align="right">$time</td>
      <td class="whiteText" align="right">
       <a href="javascript:_CANCEL('$fields[0]','$name @ $date : $time')"><img src="Pictures/cancel.gif" border="0" alt="Cancel scheduled download"></a>
      </td>
     </tr>
END
  }
 } 
 else
 {
 $code.= <<"END";
    <tr class="tableInnerHeaderError">
     <td class="whiteTextTop">
       no files scheduled downloads yet...
     </td>
     <td class="whiteTextTop" align="right">&nbsp;
     </td>
     <td class="whiteTextTop" align="right">&nbsp;
     </td>
     <td class="whiteTextTop" align="right">&nbsp;
     </td>
    </tr>
END
 }

 $code.= <<"END";
    <tr class="tableInnerHeader">
     <td class="whiteTextTop">
      &nbsp;
     </td>
     <td class="whiteTextTop" style="width:80px" align="right">
      &nbsp;
     </td>
     <td class="whiteTextTop" style="width:80px" align="right">
      &nbsp;
     </td>
     <td class="whiteTextTop" align="right" style="width:80px">
      &nbsp;
     </td>
    </tr>
    </table>
   </td>
  </tr>
 </table>
</center>
END

}

sub addValidation
{
 $values{"DATA_url"}=trim($values{"DATA_url"}); 

 #my $parts = parseUrl($values{"DATA_url"});
 #my $filename = $parts->{file};

 my @pieces = split(/\?/,$values{"DATA_url"});
 my $c = strReplace('//','|',@pieces[0]);
 $c = strReplace('/','|',$c);
 @pieces = explode('|',$c);
 $c = @pieces;
 my $filename = @pieces[$c-1];

 my $found = 0;
 foreach(@database)
 {
  @fields = explode('|',$_);
  if($filename eq @fields[2])
  {
   $found = 1;
  }
 }
 opendir(DIR, $DOWN_DIR.'/') || die "$DOWN_DIR: $!";
 my @Files = readdir(DIR);
 closedir(DIR);
 foreach(@Files)
 {
  if($filename eq $_)
  {
   $found = 1;
  }
 }

my $code= <<"END";
<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr>
   <td class="tableInnerHead">
    <span class="whiteText">
     <b>Please validate your download and correct the filename if necessary ... </b>
    </span>
   </td>
  </tr>
  <tr>
   <td>
    <table border="0" cellpadding="3" cellspacing="0" width="100%">
     <form action="index.cgi?transfers+add" method="post">
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        URL
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       $values{"DATA_url"}
       <input type="hidden" name="DATA_url" value="$values{"DATA_url"}" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Filename to store
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_name" value="$filename" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="checkbox" name="DATA_schedule" value="yes" class="blackText">Schedule download?
	<br>
       <input type="checkbox" name="DATA_mail" value="yes" class="blackText">Alert by mail when finished?
      </td>
     </tr>
END

 if($found == 1)
 {
$code.= <<"END";
     <tr class="tableInnerHeaderError">
      <td class="whiteTextTop">
        ATTENTION: a file with the given name allready exists in the database or within the download directory. Please change it or the old version will be overwritten!
      </td>
     </tr>
END
 }

$code.= <<"END";
     <tr class="tableInnerHeader">
      <td class="whiteTextTop" align="right">
       <input type="submit" value="Validate" class="blackText">
      </td>
     </tr>
     </form>
    </table>
   </td>
  </tr>
 </table>
</center>
END
 return $code;
}

sub add
{
 return <<"END";
<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr>
   <td class="tableInnerHead">
    <span class="whiteText">
     <b>Add a file to download</b>
    </span>
   </td>
  </tr>
  <tr>
   <td>
    <table border="0" cellpadding="3" cellspacing="0" width="100%">
     <form action="index.cgi?add" method="post">
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        URL
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_url" value="" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop" align="right">
       <input type="submit" value="Get it" class="blackText">
      </td>
     </tr>
     </form>
    </table>
   </td>
  </tr>
 </table>
</center>
END
}

sub optionsSave
{
 $DOWN_DIR=$values{"DATA_path"};
 $WGET=$values{"DATA_wget"};
 $TIMEOUT=$values{"DATA_timeout"};
 $EMAIL=$values{"DATA_email"};
 $SMTP=$values{"DATA_smtp"};
 &savePreferences;
 
 return <<"END";
<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr>
   <td class="tableInnerHead">
    <span class="whiteText">
     <b>Preferences (saved)</b>
    </span>
   </td>
  </tr>
  <tr>
   <td>
    <table border="0" cellpadding="3" cellspacing="0" width="100%">
     <form action="index.cgi?options" method="post">
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Download path
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_path" value="$DOWN_DIR" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Path to wget
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_wget" value="$WGET" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Reload timeout for transfers page
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_timeout" value="$TIMEOUT" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Default mail recipient for alert messages
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_email" value="$EMAIL" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Default SMTP server
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_smtp" value="$SMTP" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop" align="right">
       <input type="submit" value="Save" class="blackText">
      </td>
     </tr>
     </form>
    </table>
   </td>
  </tr>
 </table>
</center>
END
}

sub options
{
 return <<"END";
<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr>
   <td class="tableInnerHead">
    <span class="whiteText">
     <b>Preferences</b>
    </span>
   </td>
  </tr>
  <tr>
   <td>
    <table border="0" cellpadding="3" cellspacing="0" width="100%">
     <form action="index.cgi?options" method="post">
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Download path
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_path" value="$DOWN_DIR" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Path to wget
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_wget" value="$WGET" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Reload timeout for transfers page
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_timeout" value="$TIMEOUT" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Default mail recipient for alert messages
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_email" value="$EMAIL" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop">
        Default SMTP server
      </td>
     </tr>
     <tr>
      <td class="whiteText">
       <input type="text" name="DATA_smtp" value="$SMTP" class="blackText" style="width:100%">
      </td>
     </tr>
     <tr class="tableInnerHeader">
      <td class="whiteTextTop" align="right">
       <input type="submit" value="Save" class="blackText">
      </td>
     </tr>
     </form>
    </table>
   </td>
  </tr>
 </table>
</center>
END
}

sub welcome
{
 return <<"END";
<center>
 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr><td class="tableInnerHead"><span class="whiteText"><b>
    About
  </b></span></td></tr><tr><td><table border="0" cellpadding="3" cellspacing="0" width="100%"><tr class="tableInnerHeader"><td class="whiteTextTop">
    ReDoMa.PERL - Version 0.7 
  </td></tr><tr><td class="whiteText">
    Bought to you by <a href="mailto:bob\@fesch.lu" class="whiteTextU">Fisch Bob</a>
    <br>
    Check out my site <a href="http://www.fesch.lu" class="whiteTextU">http://www.fesch.lu</a>
    <br>
  </td></tr><tr class="tableInnerHeader"><td class="whiteTextTop" align="right">&nbsp;</td></tr></table></td></tr></table>

 <br>

 <table class="tableInner" cellpadding="0" cellspacing="0">
  <tr><td class="tableInnerHead"><span class="whiteText"><b>
    Info
  </b></span></td></tr><tr><td><table border="0" cellpadding="3" cellspacing="0" width="100%"><tr class="tableInnerHeader"><td class="whiteTextTop">
    Tested by
  </td></tr><tr><td class="whiteText">
  <br>
   <ul>
    <li class="whiteText"><a href="mailto:bob\@fesch.lu" class="whiteTextU">Fisch Bob</a> @ IpCOP 1.4.0a1 & 1.3.0</li>
    <li class="whiteText"><a href="mailto:Argenlos\@team.co.fr" class="whiteTextU">Argenlos</a> @ SME 5.6</li>
    <li class="whiteText"><a href="mailto:krazykool\@free.fr" class="whiteTextU">KrAzYkOoL</a> @ SME 6.0.1</li>
<!--
    <li class="whiteText"><a href="http://www.service-computer.fr.st" class="whiteTextU">Sebastien</a> @ SME 6b3</li>
-->
   </ul>
  </td></tr><tr class="tableInnerHeader"><td class="whiteTextTop" align="right">Send me a mail and I'll add you to this list!</td></tr></table></td></tr></table>

</center>
END
}

sub top
{
 return <<"END";
   <table cellpadding="5" cellspacing="0">
    <tr>
     <td class="whiteText" align="center" width="150">
      <a href="index.cgi?welcome" class="whiteText" style="text-decoration:underline">
       <img src="Pictures/redoma.jpg" border="0" alt="ReDoMa">
      </a>
     </td>
     <td class="whiteText" align="center" width="100">
      <a href="index.cgi?add" class="whiteTextU">
       <img src="Pictures/add.gif" border="0" alt="Add a file to download"><br>
       Add
      </a>
     </td>
     <td class="whiteText" align="center" width="100">
      <a href="index.cgi?transfers" class="whiteTextU">
       <img src="Pictures/transfers.gif" border="0" alt="Transfers"><br>
       Transfers
      </a>
     </td>
     <td class="whiteText" align="center" width="100">
      <a href="index.cgi?schedule" class="whiteTextU">
       <img src="Pictures/schedule2.gif" border="0" alt="Scheduler"><br>
       Scheduler
      </a>
     </td>
     <td class="whiteText" align="center" width="100">
      <a href="index.cgi?files" class="whiteTextU">
       <img src="Pictures/files.gif" border="0" alt="Files downloaded"><br>
       Files
      </a>
     </td>
     <td class="whiteText" align="center" width="100">
      <a href="index.cgi?options" class="whiteTextU">
       <img src="Pictures/options.gif" border="0" alt="Configure ReDoMa"><br>
       Preferences
      </a>
     </td>
     </td>
    </tr>
   </table>
END
}


sub parseForm
{
  local($fields, $name, $value, $data);
  #Split standard input into fields
  read(STDIN, $data, $ENV{"CONTENT_LENGTH"});
  #print $data;
  @fields = split(/&/,$data);

  #Split the fields into names and values, creating 
  #an associative array indexed by the names

  $count = 0;
  foreach $item (@fields) {
      #print $item;
      ($name, $value) = split(/=/,$item);
      #$name = &UnescapeString($name);
      $value = &urlDecode($value);
      if ($name eq "Topping") {
	$count = $count+1;
        if ($count gt "1") {
	  $values{$name} .= ", ";
	  $values{$name} .= $value;
        }
	else {
	  $values{$name} = $value;
        }
      }
      else {
	$values{$name} = $value;
      }
  }
}

sub urlDecode
{
 my $URLdecode=shift;
 $URLdecode=~tr/+/ /;
 $URLdecode=~s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;
 return $URLdecode;
} 

sub EncodeChar($)
{
 my ($foo) = @_;
 return ($foo eq " ") ? "+" : "%" . sprintf "%lx", ord($foo);
}

sub urlEncode
{
 my $URLencode=shift;
 $URLencode=~tr/+/ /;
 $URLencode=~ s/([^\w\-\.\@])/EncodeChar($1)/eg; 
 #$URLencode=~s/%pack("C",hex($1))/([a-fA-F0-9][a-fA-F0-9])/eg;
 return $URLencode;
} 

sub parseUrl 
{ 
 #--------------------------------------- 
 # Pass in a URL. Hashref is returned.       
 my $url = shift;       
 my (@parts) = $url =~ m|^([^:]+)://([^/]+)(?:(/.+?/?)([^/]+)?)?$|;      
 my (%slice) = ();      
 @slice{qw/protocol domain path file/} = @parts;      
 return \%slice;
}

sub trim
{
# my $temp  = shift;
# #$temp = s/^ |\t|\n//;
# chomp($temp);
# ##print "$temp<br>";
# return $temp;
  my $temp = shift;
  $temp =~ s/^\s*//;
  $temp =~ s/\s*$//;
  return $temp;
}

sub round
{
 my $who = shift;
 my $many = shift;
 my @pieces = split(/\./,$who);
 return $pieces[0].'.'.substr($pieces[1],0,$many);
}

# function to nicely print sizes
sub niceSize
{
 my $size = shift;
 if($size ne 'unspecified')
 {
  my $ret=$size.'&nbsp;B';

  if($size>1024) {$ret=round($size/1024,2).'&nbsp;KB';}
  if($size>1024*1024) {$ret=round($size/(1024*1024),2).'&nbsp;MB';}
  if($size>1024*1024*1024) {$ret=round($size/(1024*1024*1024),2).'&nbsp;GB';}
  if($size>1024*1024*1024*1024) {$ret=round($size/(1024*1024*1024*1024),2).'&nbsp;TB';}

  return $ret;
 }
 else
 {
  if($size==0)
  {
   return ($size.'&nbsp;B');
  }
  else
  {
   return $size;
  }
 }
}

sub niceSpeed
{
 my $size = shift;

 my $ret=$size.'&nbsp;B/s';

 if($size>1024) {$ret=round($size/1024,2).'&nbsp;KB/s';}
 if($size>1024*1024) {$ret=round($size/(1024*1024),2).'&nbsp;MB/s';}
 if($size>1024*1024*1024) {$ret=round($size/(1024*1024*1024),2).'&nbsp;GB/s';}

 return $ret;
}

sub fileExists
{
 return (-f shift);
}

sub fileSize
{
 return (-s shift);
}

sub isDir
{
 return (-d shift);
}

sub isFile 
{
 return (-f shift);
}

sub file
{
 open (FILE, shift) || die "couldn't open the file!";
 my @LINES;
 my $i = 0;
 while ($record = <FILE>) 
 {
  @LINES[$i] = trim($record);
  $i=$i+1;
 }
 close(FILE);
 return @LINES;
}

sub strReplace
{
 my $what = shift;
 my $with = shift;
 my $who = shift;
 $who =~ s/$what/$with/g;
 return $who;
}

sub unlink2
{
 $filename = shift;
 `rm $filename`;
}

sub explode
{
 my $splitter = shift;
 my $who = shift;
 my $tmp;
 my @result;
 my $i = 0;
 my $count = 0;

 while($i<length($who))
 {
  if(substr($who,$i,length($splitter)) eq $splitter)
  {
   $result[$count]=$tmp;
   $tmp='';
   $count++;
   $i+=length($splitter);
  }
  else
  {
   $tmp=$tmp.substr($who,$i,1);
   $i++;
  }
 }
 $result[$count]=$tmp;
 return @result;
}



