#!/usr/bin/perl

# change to script dir :-)
my @pieces = explode('scheduler.pl',$0);
chdir(@pieces[0]);
my $DIR = @pieces[0];

my @database;
my @schedule;
my $DOWN_DIR;
my $TIMEOUT;
my $WGET;
my $EMAIL;
my $SMTP;

&loadPreferences;
&loadDatabase;
&loadSchedule;

 # Get date
 my @date=localtime(time());
 my $year   = sprintf("%04d",$date[5]+1900);
 my $month  = sprintf("%02d",$date[4]+1);
 my $day    = sprintf("%02d",$date[3]);
 my $hour   = sprintf("%02d",$date[2]);
 my $minute = sprintf("%02d",$date[1]);

 print "Checking what download to start ...\n";
 print "===================================\n";
 print "$year.$month.$day @ $hour:$minute\n";
 print "------------------\n";


 my @dbCopy;
 my $count = 0;
 foreach(@schedule)
 {

  #my $tmp;
  #my $i = 18;
  #$tmp = substr($_,length($_)-$i,1);
  #while(substr($_,length($_)-$i-1,1)!='|')
  #{ 
  # $i++;
  # $tmp=substr($_,length($_)-$i,1).$tmp
  #}
  
  #@fields[1]=$tmp;
  #@fields[2]=substr($_,length($_)-16,4);
  #@fields[3]=substr($_,length($_)-11,2);
  #@fields[4]=substr($_,length($_)-8,2);
  #@fields[5]=substr($_,length($_)-5,2);
  #@fields[6]=substr($_,length($_)-2,2);

  #print "$_\n";
  @fields = explode('|',$_);

  print "@fields[2].@fields[3].@fields[4] @ @fields[5]:@fields[6]\n";

  if(
     ((@fields[2] eq '????' )||(@fields[2] eq $year))   &&
     ((@fields[3] eq '??'   )||(@fields[3] eq $month))  &&
     ((@fields[4] eq '??'   )||(@fields[4] eq $day))    &&
     ((@fields[5] eq '??'   )||(@fields[5] eq $hour))   &&
     ((@fields[6] eq '??'   )||(@fields[6] eq $minute))
    )
  {

   if(
      ((@fields[2] eq '????' )) ||
      ((@fields[3] eq '??'   )) ||
      ((@fields[4] eq '??'   )) ||
      ((@fields[5] eq '??'   )) ||
      ((@fields[6] eq '??'   ))
     )
   {
    @dbCopy[$count]=$_;
    $count++;
   }

   my $name = '';
   my $url = '';

   my @dbCopy2;
   my $count2 = 0;
   foreach (@database)
   {
    @files = explode('|',$_);
    if(@files[0] eq @fields[1])
    {
     $name = @files[2];
     $url  = @files[1];
     if($files[3] eq '2')
     { 
      @dbCopy2[$count2]=$files[0]."|".$files[1]."|".$files[2]."|1";
      $count2++;
     }
     else
     {
      @dbCopy2[$count2]=$_;
      $count2++;
     }
    }
    else
    {
     @dbCopy2[$count2]=$_;
     $count2++;
    }
   }
   @database=@dbCopy2;


   my $file = $DOWN_DIR.'/'.$name;
   my $pidFile = $DOWN_DIR.'/'.$name.'.pid';
   my $logFile = $DOWN_DIR.'/'.$name.'.log';

   if(fileExists($file))
   {
    unlink($file);
   }
   if(fileExists($pidFile))
   {
    unlink($pidFile);
   }
   if(fileExists($logFile))
   {
    unlink($logFile);
   }

   &start($url,$name);
   print "Getting $name from $url\n";

  }
  else
  {
   @dbCopy[$count]=$_;
   $count++;
  }
 }
 @schedule=@dbCopy;
 &saveDatabase;
 &saveSchedule;
 
 print "\n";
 print "Checking if alert has to be send...\n";
 print "===================================\n";

 my @dbCopy;
 my $count = 0;
 foreach (@database)
 {
  @fields = explode('|',$_);
  if(@fields[3] eq '1')
  {

   my $state = 'stopped';
   if(fileExists($DOWN_DIR.'/'.$fields[2].'.pid'))
   {
    $pid = getPID($DOWN_DIR.'/'.$fields[2].'.pid') ;
    if(isDir('/proc/'.$pid))
    {
     $state='running';
    }
    else
    {
     $state='stopped';
    }
   }

   my $done='???';
   my $speed='??? B/s';
   my $whatError = '';
   my $length='unspecified';
   if(fileExists($DOWN_DIR.'/'.$fields[2].'.log'))
   { 
    my @log = file($DOWN_DIR.'/'.$fields[2].'.log');
    foreach(@log)
    {
     $line=$_;
     if($line ne '')
     {
      my $search = 'Length:'; 
      if($line =~ /$search/g)
      {
       my @pieces = split(/:/,$line);
       @pieces = split(/\[/,$pieces[1]);
       @pieces = split(/\(/,$pieces[0]);
	$length = strReplace(',','',$pieces[0]);
       $totalSize+=$length ;
      }
  
      my $search = 'ERROR'; 
      if($line =~ /$search/g)
      {
        $where = pos($line);
        $state = 'error';
        $whatError = '#'.substr($line,$where,4);
      }

      my @pieces = split(/%/,$line);
      $search = 'B/s'; 
      if($pieces[1] =~ /$search/g)
      {
       $speed=trim($pieces[1]);
       #print $speed."<br>";

       @pieces = split(/OK/,$pieces[0]);
       #print $pieces[0].'<br>'; 
       $done = trim(substr($pieces[0],length($pieces[0])-3,length($pieces[0])));
       #print $done."<br>";
      }

     }
    }

    if($speed ne '??? B/s')
    { 
     my @others=split(/ /,$speed);
     my $baseSpeed = @others[0];
     if(@others[1] eq 'KB/s') {$baseSpeed*=1024;}
     if(@others[1] eq 'MB/s') {$baseSpeed*=1024*1024;}
     if(@others[1] eq 'GB/s') {$baseSpeed*=1024*1024*1024;} # just for fun :-)
     #print $baseSpeed."<br>";
     if($state eq 'running')
     {
      $totalSpeed+=$baseSpeed;
     }
    }

   }
   else
   {
    $done='0';
   } 
   
   if($done eq '100')
   {
    #send mail

use Net::SMTP;
$smtp = Net::SMTP->new($SMTP) or die "Can not connect to the mail server : $! \n"; 
$smtp->mail($EMAIL);
$smtp->to($EMAIL); 
$smtp->data();
$smtp->datasend("Subject: ReDoMa download alert!\n");
$smtp->datasend("To: $EMAIL\n");
$smtp->datasend("\n");
$smtp->datasend("ReDoMa has finished downloading for the following URL:\n");
$smtp->datasend("\n");
$smtp->datasend($fields[1]."\n");
$smtp->datasend("\n");
$smtp->datasend("and has saved the file as:\n");
$smtp->datasend("\n");
$smtp->datasend($DIR.$DOWN_DIR.'/'.$fields[2]." [".niceSize(fileSize($DIR.$DOWN_DIR.'/'.$fields[2]))."]\n");
$smtp->datasend("\n");
$smtp->datasend("________________________________________\n");
$smtp->datasend("This message has been send automatically\n");
$smtp->datasend("by ReDoMa. Do not respond to it. For any\n");
$smtp->datasend("other information or question about this\n");
$smtp->datasend("please visit: http://www.fesch.lu/redoma\n");
$smtp->dataend();
$smtp->quit;

print "$fields[1] => $fields[2]\n";

    @dbCopy[$count]=$fields[0]."|".$fields[1]."|".$fields[2]."|2";
    $count++;
   }
   else
   {
    @dbCopy[$count]=$_;
    $count++;
   }

  }
  else
  {
   @dbCopy[$count]=$_;
   $count++;
  }
 }
 @database=@dbCopy;
 &saveDatabase;


sub loadPreferences
{
 my @data = file('redoma.conf');
 $DOWN_DIR = @data[0];
 $WGET     = @data[1];
 $TIMEOUT  = @data[2];
 $EMAIL    = @data[3];
 $SMTP     = @data[4];

 if($DOWN_DIR eq '')
 {
  $DOWN_DIR ='Downloads'
 }
 if($WGET eq '')
 {
  $WGET = '/usr/local/bin/wget';
 }
 if($TIMEOUT eq '')
 {
  $TIMEOUT = '30';
 }
}


sub loadDatabase
{
 open (TRANSFERS, "transfers.db") || die "couldn't open the file!";
 my $i = 0;
 while ($record = <TRANSFERS>)
 {
  if(trim($record) ne '')
  {
   @database[$i] = trim($record);
   $i=$i+1;
  }
 }
 close(TRANSFERS);
}

sub loadSchedule
{
 open (TRANSFERS, "schedules.db") || die "couldn't open the file!";
 my $i = 0;
 while ($record = <TRANSFERS>)
 {
  if(trim($record) ne '')
  {
   @schedule[$i] = trim($record);
   $i=$i+1;
  }
 }
 close(TRANSFERS);
}

sub saveSchedule
{
 open (TRANSFERS, ">schedules.db") or die "no such file";
 foreach (@schedule)
 {
  if(trim($_) ne '')
  {
   print TRANSFERS "$_\n";
  }
  #print $_;
 }
 close(TRANSFERS);
}

sub trim
{
# my $temp  = shift;
# #$temp = s/^ |\t|\n//;
# chomp($temp);
# ##print "$temp<br>";
# return $temp;
  my $temp = shift;
  $temp =~ s/^\s*//;
  $temp =~ s/\s*$//;
  return $temp;
}

sub file
{
 open (FILE, shift) || die "couldn't open the file!";
 my @LINES;
 my $i = 0;
 while ($record = <FILE>)
 {
  @LINES[$i] = trim($record);
  $i=$i+1;
 }
 close(FILE);
 return @LINES;
}

sub start
{
 my $url = shift;
 my $name = shift;

 my $a1=$DOWN_DIR.'/'.$name.'.log';
 my $a2=$DOWN_DIR.'/'.$name;
 my $a3=$url;
 my $a4=$DOWN_DIR.'/'.$name.'.pid';

 my $command = "$WGET -b -c -o $a1 -O $a2 $a3";
 print "---> $command\n";
 my $pidSring = `$command`;
 #print $pidSring ."<br>";
 my @pieces = explode('pid',$pidSring);
 @pieces=explode('.',$pieces[1]);
 $pid = trim($pieces[0]);

 open (PID, ">$a4") or die "no such file";
 print PID"$pid\n";
 close(PID);
}

sub fileExists
{
 return (-f shift);
}

sub strReplace
{
 my $what = shift;
 my $with = shift;
 my $who = shift;
 $who =~ s/$what/$with/g;
 return $who;
}

sub explode
{
 my $splitter = shift;
 my $who = shift;
 my $tmp;
 my @result;
 my $i = 0;
 my $count = 0;

 while($i<length($who))
 {
  if(substr($who,$i,length($splitter)) eq $splitter)
  {
   $result[$count]=$tmp;
   $tmp='';
   $count++;
   $i+=length($splitter);
  }
  else
  {
   $tmp=$tmp.substr($who,$i,1);
   $i++;
  }
 }
 $result[$count]=$tmp;
 return @result;
}

sub getPID
{
 open (PID, shift) || die "couldn't open the file!";
 my $pid = <PID>; 
 close(PID);
 return trim($pid);
}

sub isDir
{
 return (-d shift);
}

sub saveDatabase
{
 @database = sort {&byFileName ($a,$b)} @database ;

 open (TRANSFERS, ">transfers.db") or die "no such file";
 foreach (@database) 
 {
  if(trim($_) ne '')
  {
   print TRANSFERS "$_\n";
  } 
  #print $_;
 }
 close(TRANSFERS);
}


sub byFileName 
{
 my @fieldsA = split(//,shift);
 my @fieldsB = split(//,shift);
 return (uc(@fieldsA[2])  cmp uc(@fieldsB[2])); 
}

sub fileSize
{
 return (-s shift);
}

# function to nicely print sizes
sub niceSize
{
 my $size = shift;
 if($size ne 'unspecified')
 {
  my $ret=$size.' B';

  if($size>1024) {$ret=round($size/1024,2).' KB';}
  if($size>1024*1024) {$ret=round($size/(1024*1024),2).' MB';}
  if($size>1024*1024*1024) {$ret=round($size/(1024*1024*1024),2).' GB';}
  if($size>1024*1024*1024*1024) {$ret=round($size/(1024*1024*1024*1024),2).' TB';}

  return $ret;
 }
 else
 {
  if($size==0)
  {
   return ($size.' B');
  }
  else
  {
   return $size;
  }
 }
}

sub round
{
 my $who = shift;
 my $many = shift;
 my @pieces = split(/\./,$who);
 return $pieces[0].'.'.substr($pieces[1],0,$many);
}

